import java.util.Scanner;

public class DemoNIM {

   Scanner scan;

   public DemoNIM() {
      scan = new Scanner(System.in);
   }

   int getNumberOfStones(int min, int max) {
      int n = -1;
      System.out.print("Enter number of stones in range [ " + min + ", " + max + " ]: ");
      n = scan.nextInt();
      return (n >= min && n <= max ? n : -1);
   }

   int humanTurn(int n) {
      int r = 0;
      while(r != 1 && r != 2 && r != 3) {
         System.out.print("No. of stones is " + n + ". How many stones you will take: " );
         r = scan.nextInt();
      }
      return r;
   }

   int machineTurn(int n) {
      int r = (n - 1) % 4;
      if (r == 0) {
         r = 1;
      }
      System.out.println("No. of stones is " + n + ". I take " + r + ".");
      return r;
   }

   public String play(boolean machineStart) {
      final int MIN_INIT_STONES = 15;
      final int MAX_INIT_STONES = 35;
      boolean machine = machineStart;

      int numberOfStones = getNumberOfStones(MIN_INIT_STONES, MAX_INIT_STONES);

      if (numberOfStones < MIN_INIT_STONES || numberOfStones > MAX_INIT_STONES) {
         return "Given number of stones is out of range";
      }
      do {
         if (machine) {
            numberOfStones -= machineTurn(numberOfStones);
         } else {
            numberOfStones -= humanTurn(numberOfStones);
         }
         machine = !machine;
      } while(numberOfStones > 0);
      return machine ? "Machine win!" : "Human win!";
   }

   public static void main(String[] args) {
      DemoNIM nim = new DemoNIM();
      String result = nim.play(true); //machine start true/false
      System.out.println("Result of the game is: " + result);
   }
}
